﻿/*
** Job Arranger for ZABBIX
** Copyright (C) 2012 FitechForce, Inc. All Rights Reserved.
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
**/
using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Data;
using System.Collections;
using jp.co.ftf.jobcontroller.Common;
//*******************************************************************
//                                                                  *
//                                                                  *
//  Copyright (C) 2012 FitechForce, Inc. All Rights Reserved.       *
//                                                                  *
//  * @author KIM 2012/11/14 新規作成<BR>                            *
//                                                                  *
//                                                                  *
//*******************************************************************
namespace jp.co.ftf.jobcontroller.JobController.Form.ScheduleEdit
{
/// <summary>
/// Container.xaml の相互作用ロジック
/// </summary>
    public partial class CalendarContainer : UserControl
    {
        #region コンストラクタ
        public CalendarContainer()
        {
            // 初期化 
            InitializeComponent();
        }
        #endregion

        #region フィールド

        /// <summary>マウスの位置</summary>
        private Point mousePosition;

        // 一旦削除（区域選択用） 
        /// <summary>マウス追従フラグ</summary>
        //private bool trackingMouseMove = false;

        // 2012.11.1一旦削除（区域選択用） 
        /// <summary>選択範囲</summary>
        //Rectangle temproaryEllipse;

        #endregion

        #region プロパティ


        /// <summary>ウィンドウ</summary>
        ContentControl _parantWindow;
        public ContentControl ParantWindow
        {
            get
            {
                return _parantWindow;
            }
            set
            {
                _parantWindow = value;
            }
        }


        /// <summary> 選択コントローラリスト</summary>
        List<System.Windows.Controls.Control> _currentSelectedControlCollection;
        public List<Control> CurrentSelectedControlCollection
        {
            get
            {
                if (_currentSelectedControlCollection == null)
                    _currentSelectedControlCollection = new List<Control>();
                return _currentSelectedControlCollection;
            }
        }

        /// <summary>カレンダーID</summary>
        private string _calendarId;
        public string CalendarId
        {
            get
            {
                return _calendarId;
            }
            set
            {
                _calendarId = value;
            }
        }

        /// <summary>更新日</summary>
        private string _updDate;
        public string UpdDate
        {
            get
            {
                return _updDate;
            }
            set
            {
                _updDate = value;
            }
        }

        /// <summary>仮更新日</summary>
        private string _tmpUpdDate;
        public string TmpUpdDate
        {
            get
            {
                return _tmpUpdDate;
            }
            set
            {
                _tmpUpdDate = value;
            }
        }

        #endregion

        #region データ格納場所

        /// <summary>カレンダー管理テーブル</summary>
        public DataTable CalendarControlTable { get; set; }

        /// <summary>カレンダー稼働日テーブル</summary>
        public DataTable CalendarDetailTable { get; set; }

        /// <summary>年毎カレンダー稼働日テーブル</summary>
        public DataTable YearCalendarDetailTable { get; set; }


        #endregion

        #region イベント

        //*******************************************************************
        /// <summary>コンテナを右クリック</summary>
        /// <param name="sender">源</param>
        /// <param name="e">マウスイベント</param>
        //*******************************************************************
        private void UserControl_MouseRightButtonDown(object sender, MouseButtonEventArgs e)
        {
            this.ContextMenu.Visibility = Visibility.Visible;
        }

        private void calendar_DisplayModeChanged(object sender, CalendarModeChangedEventArgs e)
        {
            Calendar calendar = sender as Calendar;
            if (calendar.DisplayMode == CalendarMode.Year || calendar.DisplayMode == CalendarMode.Decade)
            {
                calendar.DisplayMode = CalendarMode.Month;
            }

        }


        private void left_arrow_click(object sender, EventArgs e)
        {
            //YearCalendarDetailTable.Clear();
            String year = (Convert.ToInt16(textBox_year.Text) - 1).ToString();
            SetYearCalendarDetail(year);
            
        }

        private void right_arrow_click(object sender, EventArgs e)
        {
            //YearCalendarDetailTable.Clear();
            String year = (Convert.ToInt16(textBox_year.Text) + 1).ToString();
            SetYearCalendarDetail(year);

        }


        #endregion

        #region publicメッソド
        //*******************************************************************
        /// <summary>初回、矢印遷移の場合稼働日セット</summary>
        /// <param name="year">年</param>
        //*******************************************************************
        public void SetYearCalendarDetail(String year)
        {
            if (year != null)
            {
                textBox_year.Text = year;
            }
            else
            {
                year = textBox_year.Text;
            }
            ClearSelectedDates();
            SetCalendarDispayStartEnd(Convert.ToInt32(year));
            String from = year + "0101";
            String to = year + "1231";
            DataRow[] rows = CalendarDetailTable.Select("operating_date>='" + from + "' and operating_date<='" + to + "'");
            SetSelectedDates(rows);
            DataRow[] maxRows = CalendarDetailTable.Select("operating_date = MAX(operating_date)");
            last_operation_day_value.Text = "";
            if (maxRows.Length > 0)
            {
                last_operation_day_value.Text = ConvertUtil.ConverIntYYYYMMDD2Date((Int32)maxRows[0]["operating_date"]).ToShortDateString();
            }

        }

        #endregion

        #region privateメッソド

        //*******************************************************************
        /// <summary>カレンダー表示開始、終了日をセット</summary>
        /// <param name="year">年</param>
        //*******************************************************************
        private void SetCalendarDispayStartEnd(int currentYear)
        {

            calendar1.DisplayDateStart = new DateTime(currentYear, 1, 1);
            calendar1.DisplayDateEnd = new DateTime(currentYear, 1, DateTime.DaysInMonth(currentYear, 1));
            calendar2.DisplayDateStart = new DateTime(currentYear, 2, 1);
            calendar2.DisplayDateEnd = new DateTime(currentYear, 2, DateTime.DaysInMonth(currentYear, 2));
            calendar3.DisplayDateStart = new DateTime(currentYear, 3, 1);
            calendar3.DisplayDateEnd = new DateTime(currentYear, 3, DateTime.DaysInMonth(currentYear, 3));
            calendar4.DisplayDateStart = new DateTime(currentYear, 4, 1);
            calendar4.DisplayDateEnd = new DateTime(currentYear, 4, DateTime.DaysInMonth(currentYear, 4));
            calendar5.DisplayDateStart = new DateTime(currentYear, 5, 1);
            calendar5.DisplayDateEnd = new DateTime(currentYear, 5, DateTime.DaysInMonth(currentYear, 5));
            calendar6.DisplayDateStart = new DateTime(currentYear, 6, 1);
            calendar6.DisplayDateEnd = new DateTime(currentYear, 6, DateTime.DaysInMonth(currentYear, 6));
            calendar7.DisplayDateStart = new DateTime(currentYear, 7, 1);
            calendar7.DisplayDateEnd = new DateTime(currentYear, 7, DateTime.DaysInMonth(currentYear, 7));
            calendar8.DisplayDateStart = new DateTime(currentYear, 8, 1);
            calendar8.DisplayDateEnd = new DateTime(currentYear, 8, DateTime.DaysInMonth(currentYear, 8));
            calendar9.DisplayDateStart = new DateTime(currentYear, 9, 1);
            calendar9.DisplayDateEnd = new DateTime(currentYear, 9, DateTime.DaysInMonth(currentYear, 9));
            calendar10.DisplayDateStart = new DateTime(currentYear, 10, 1);
            calendar10.DisplayDateEnd = new DateTime(currentYear, 10, DateTime.DaysInMonth(currentYear, 10));
            calendar11.DisplayDateStart = new DateTime(currentYear, 11, 1);
            calendar11.DisplayDateEnd = new DateTime(currentYear, 11, DateTime.DaysInMonth(currentYear, 11));
            calendar12.DisplayDateStart = new DateTime(currentYear, 12, 1);
            calendar12.DisplayDateEnd = new DateTime(currentYear, 12, DateTime.DaysInMonth(currentYear, 12));

        }

        //*******************************************************************
        /// <summary>カレンダー稼働日クリア</summary>
        //*******************************************************************
        private void ClearSelectedDates()
        {
            calendar1.SelectedDates.Clear();
            calendar2.SelectedDates.Clear();
            calendar3.SelectedDates.Clear();
            calendar4.SelectedDates.Clear();
            calendar5.SelectedDates.Clear();
            calendar6.SelectedDates.Clear();
            calendar7.SelectedDates.Clear();
            calendar8.SelectedDates.Clear();
            calendar9.SelectedDates.Clear();
            calendar10.SelectedDates.Clear();
            calendar11.SelectedDates.Clear();
            calendar12.SelectedDates.Clear();
        }

        //*******************************************************************
        /// <summary>カレンダー選択日付をセット</summary>
        /// <param name="rows">カレンダー詳細データ</param>
        //*******************************************************************
        private void SetSelectedDates(DataRow[] rows)
        {
            foreach (DataRow row in rows)
            {
                DateTime date = ConvertUtil.ConverIntYYYYMMDD2Date(Convert.ToDecimal(row["operating_date"]));
                SetSelectDate(date);
            }
        }

        //*******************************************************************
        /// <summary>カレンダー選択日付をセット</summary>
        /// <param name="date">カレンダー稼動日</param>
        //*******************************************************************
        private void SetSelectDate(DateTime date)
        {
            if (date.Year == GetCurrentYear())
            {
                switch (date.Month)
                {
                    case 1:
                        calendar1.SelectedDates.Add(date);
                        break;
                    case 2:
                        calendar2.SelectedDates.Add(date);
                        break;
                    case 3:
                        calendar3.SelectedDates.Add(date);
                        break;
                    case 4:
                        calendar4.SelectedDates.Add(date);
                        break;
                    case 5:
                        calendar5.SelectedDates.Add(date);
                        break;
                    case 6:
                        calendar6.SelectedDates.Add(date);
                        break;
                    case 7:
                        calendar7.SelectedDates.Add(date);
                        break;
                    case 8:
                        calendar8.SelectedDates.Add(date);
                        break;
                    case 9:
                        calendar9.SelectedDates.Add(date);
                        break;
                    case 10:
                        calendar10.SelectedDates.Add(date);
                        break;
                    case 11:
                        calendar11.SelectedDates.Add(date);
                        break;
                    case 12:
                        calendar12.SelectedDates.Add(date);
                        break;
                }
            }
        }

        //*******************************************************************
        /// <summary>カレンダー選択日付をセット</summary>
        /// <return>現在表示年</return>
        //*******************************************************************
        private int GetCurrentYear()
        {
            return Convert.ToInt32(textBox_year.Text);
        }

        #endregion
    }

}
